目录

LeetCode1178. 猜字谜

1178. 猜字谜

Difficulty: 困难

外国友人仿照中国字谜设计了一个英文版猜字谜小游戏,请你来猜猜看吧。

字谜的迷面 puzzle 按字符串形式给出,如果一个单词 word 符合下面两个条件,那么它就可以算作谜底:

  • 单词 word 中包含谜面 puzzle 的第一个字母。
  • 单词 word 中的每一个字母都可以在谜面 puzzle 中找到。
    例如,如果字谜的谜面是 “abcdefg”,那么可以作为谜底的单词有 “faced”, “cabbage”, 和 “baggage”;而 “beefed”(不含字母 “a”)以及 “based”(其中的 “s” 没有出现在谜面中)都不能作为谜底。

返回一个答案数组 answer,数组中的每个元素 answer[i] 是在给出的单词列表 words 中可以作为字谜迷面 puzzles[i] 所对应的谜底的单词数目。

示例:

输入:
words = ["aaaa","asas","able","ability","actt","actor","access"], 
puzzles = ["aboveyz","abrodyz","abslute","absoryz","actresz","gaswxyz"]
输出:[1,1,3,2,4,0]
解释:
1 个单词可以作为 "aboveyz" 的谜底 : "aaaa" 
1 个单词可以作为 "abrodyz" 的谜底 : "aaaa"
3 个单词可以作为 "abslute" 的谜底 : "aaaa", "asas", "able"
2 个单词可以作为 "absoryz" 的谜底 : "aaaa", "asas"
4 个单词可以作为 "actresz" 的谜底 : "aaaa", "asas", "actt", "access"
没有单词可以作为 "gaswxyz" 的谜底,因为列表中的单词都不含字母 'g'

提示

  • 1 <= words.length <= 10^5
  • 4 <= words[i].length <= 50
  • 1 <= puzzles.length <= 10^4
  • puzzles[i].length == 7
  • words[i][j], puzzles[i][j] 都是小写英文字母。
  • 每个 puzzles[i] 所包含的字符都不重复。

解法一

前几天的每日一题,看群消息时看见了,群友提到了位运算和枚举子集,所以直接往这个方向想了,一发 AC。首先将所有的 word 进行状态压缩转换成二进制,然后用 hash 表统计下个数,再遍历所有的puzzle,并且枚举puzzle的子集,这里 puzz 比较短,所以我们直接按照 puzz 各个字符的的选取状态进行枚举,然后在 hash 表中找到对应的次数就行了,注意 puzz 的第一个字符必须包含。

class Solution {
    public List<Integer> findNumOfValidWords3(String[] words, String[] puzzles) {
        HashMap<Integer, Integer> map = new HashMap<>();
        //50*10^5
        for (int i = 0; i < words.length; i++) {
            char[] word = words[i].toCharArray();
            int key = 0;
            for (int j = 0; j < word.length; j++) {
                key |= 1<<(word[j]-'a');
            }
            map.put(key, map.getOrDefault(key, 0)+1);
        }
        //枚举 puzzles[i] 的子集 10^4*2^7*7
        //word 包含 puzz 的第一个字母 & puzz 包含 word 所有字母
        List<Integer> res = new ArrayList<>();
        for (int i = 0; i < puzzles.length; i++) {
            char[] puzz = puzzles[i].toCharArray();
            int cnt = 0;
            //枚举子集复杂度:2^p*p (p 为 puzz[i] 长度 7)
            for (int s = 0; s < (1<<puzz.length); s++) {
                int key = 0;
                //puzz[0] 必选
                if ((s&1)!=1) continue;
                for (int k = 0; k < puzz.length; k++) {
                    if (((s>>>k)&1)==1) {
                        key |= 1<<(puzz[k]-'a');
                    }
                }
                cnt += map.getOrDefault(key, 0);
            }
            res.add(cnt);
        }
        return res;
    }
}

解法二

看了题解后学习到的一种更快的 枚举二进制子集 的方法

//更优的枚举二进制子集的方法
public List<Integer> findNumOfValidWords(String[] words, String[] puzzles) {
    HashMap<Integer, Integer> map = new HashMap<>();
    //50*10^5
    for (int i = 0; i < words.length; i++) {
        char[] word = words[i].toCharArray();
        int key = 0;
        for (int j = 0; j < word.length; j++) {
            key |= 1<<(word[j]-'a');
        }
        map.put(key, map.getOrDefault(key, 0)+1);
    }
    //word 包含 puzz 的第一个字母 & puzz 包含 word 所有字母
    List<Integer> res = new ArrayList<>();
    for (int i = 0; i < puzzles.length; i++) {
        char[] puzz = puzzles[i].toCharArray();
        int cnt = 0, mask = 0;
        for (int j = 1; j < puzz.length; j++) {
            mask |= (1<<(puzz[j]-'a'));
        }
        //枚举子集复杂度:2^k (k 为 mask 中 1 的个数,最多为 7)
        int sub = mask;
        do {
            cnt += map.getOrDefault(sub|(1<<(puzz[0]-'a')), 0);
            sub = (sub-1) & mask;
        } while (sub != mask);
        res.add(cnt);
    }
    return res;
}

// &mask 保证了 sub 一定是 mask 的子集,同时 sub 不断的减一,最终会减到 0
//s = 101
//1. sub = 101
//2. sub = 100 & 101 = 100
//3. sub = 011 & 101 = 001
//4. sub = 000 & 101 = 000
//5. sub = 111 & 101 = 101 (取反全为 1,回到 mask,将空集也包含进去)

实际上上面的解法是针对下面这种枚举二进制子集方法的优化,不过下面这个解法在这题的时间复杂度比较高 $O(2^{26})$ 会直接 T 掉

int cnt = 0, mask = 0;
for (int j = 1; j < puzz.length; j++) {
    mask |= (1<<(puzz[j]-'a'));
}
//枚举子集复杂度:2^n (n 为二进制长度,这里为 26)
for (int s = 0; s <= mask; s++) {
    if ((s|mask) == mask) {
        cnt += map.getOrDefault(s|(1<<(puzz[0]-'a')), 0);
    }
}

解法三

字典树的做法,和上面的解法本质上一样的,只是采用的数据结构不一样,上面的解法采用的是哈希表存储,这里采用字典树存储,理论上来讲这里字典树的方法应该会比 hash 表慢,但是在 lc 提交上看这种方法是最快的,可能是哈希表常数太大了

class Node {
    Node[] next;
    int cnt;
    public Node() {
        next = new Node[26];
    }
}

Node root;

public void add(Node node, String str, int index) {
    if (index == str.length()) {
        node.cnt++;
        return;
    }
    int c = str.charAt(index)-'a';
    if (node.next[c] == null) {
        node.next[c] = new Node();
    }
    add(node.next[c], str, index+1);
}

public int dfs(Node cur, char[] puzz, char req, int idx) {
    if (cur == null) return 0;
    if (idx == puzz.length) {
        return cur.cnt;
    }
    int res = 0;
    //选择当前元素
    res += dfs(cur.next[puzz[idx]-'a'], puzz, req, idx+1);
    //不选择当前元素(req 必须选)
    if (puzz[idx] != req) {
        res += dfs(cur, puzz, req, idx+1);
    }
    return res;
}

//2^26
public List<Integer> findNumOfValidWords(String[] words, String[] puzzles) {
    root = new Node();
    for (int i = 0; i < words.length; i++) {
        char[] word = words[i].toCharArray();
        Arrays.sort(word);
        StringBuilder sb = new StringBuilder();
        for (int j = 0; j < word.length; j++) {
            if (j==0 || word[j]!=word[j-1]) {
                sb.append(word[j]);
            }
        }
        add(root, sb.toString(), 0);
    }
    //dfs 分解 puzz 子集
    List<Integer> res = new ArrayList<>();
    for (int i = 0; i < puzzles.length; i++) {
        char[] puzz = puzzles[i].toCharArray();
        Arrays.sort(puzz);
        res.add(dfs(root, puzz, puzzles[i].charAt(0), 0));
    }
    return res;
}